#ifndef __XFS_MP_TYPES_H__
#define __XFS_MP_TYPES_H__

#include <linux/buffer_head.h>
#include "xfs_iomap.h"

#define MP_MIN_NR		(128)

typedef struct mpiomap {
        xfs_mount_t             *mp;
        xfs_iocore_t            *io;
        xfs_fileoff_t           offset_fsb;
        xfs_fileoff_t           end_fsb;
        xfs_fileoff_t           last_fsb;
        xfs_filblks_t           count_fsb;
        xfs_fsblock_t           firstfsb;
        xfs_fsize_t             isize;
        int                     nimaps;
        xfs_bmbt_irec_t         imap;
}mpiomap_t;

typedef struct mprwpage {
	int			delalloc;
	int			unmapped;
	int			unwritten;
	struct inode		*inode;
}mprwpage_t;

typedef struct mppgstcnv {
	struct buffer_head	*bh_arr[MAX_BUF_PER_PAGE];
	struct buffer_head	*bh;
	struct buffer_head	*head;
	xfs_iomap_t		*iomp;
	xfs_iomap_t		iomap;
	loff_t			offset;
	unsigned long           p_offset;
	__uint64_t              end_offset;
	pgoff_t                 end_index;
	pgoff_t			last_index;
	pgoff_t			tlast;
}mppgstcnv_t;

#endif /* __XFS_MP_TYPES_H__ */

